/*****************************************************************************/
say '/************************************************************************'
say '*                                                                       *'
say '* VisualAge C++ for OS/2 Version 3.0                                    *'
say '*                                                                       *'
say '* IBM(R) VisualAge(TM) C++ for OS/2(R), Version 3                       *'
say '* (C)Copyright IBM Corp. 1995,1996                                      *'
say '* - Licensed Material - Program-Property of IBM - All Rights Reserved   *'
say '*                                                                       *'
say '*************************************************************************/'

say ''
say 'CTO307FX: '
say 'This program corrects a compression error introduced by applying CTO307.'
say 'If you have not applied CTO307 to your VisualAge installation or your'
say 'VisualAge installable image please exit now.'
say ''
say 'Do you wish to continue (y/n) ?'

answer = linein()
parse upper var answer answer
if answer \= 'Y' then
  exit

'@echo off'

/* Get cppmain */
cppdir = VALUE(CPPMAIN,,'OS2ENVIRONMENT')
/*newdir = '"'
newdir = overlay(cppdir,'"',2)
cppdir = overlay('"',newdir,length(newdir)+1)
*/

if cppdir = '' then
do
  say 'The environment variable CPPMAIN is not set.  '
  say 'If you have copied VisualAge for C++ onto a drive, and installed'
  say 'CTO307 onto the image then please enter the drive and directory now.'
  say ''
  cppdir = linein()
  if cppdir = '' then
    say 'No directory entered.  Exiting...'
end

/* Get cppwork */
workdir = VALUE(CPPWORK,,'OS2ENVIRONMENT')

if workdir \= "" then
do
/*  newdir = '"'
  newdir = overlay(workdir,'"',2)
  workdir = overlay('"',newdir,length(newdir)+1)
*/
end
if workdir = '' then
do
  say 'The environment variable CPPWORK is not set.  '
  say 'If you have copied the VisualAge for C++ samples onto a drive, and '
  say 'installed CTO307 onto the image then please enter the drive and '
  say 'directory now.'
  say  ''
  workdir = linein()
  if workdir = '' then
    say 'No directory entered.  Exiting...'
end



/* Get a temp directory */
tempdir = VALUE(TMP,,'OS2ENVIRONMENT')
if tempdir = '' then
do
  tempdir = cppdir'\TEMP'
  'mkdir 'tempdir
end
else
do
/*  newdir = '"'
  newdir = overlay(tempdir,'"',2)
  tempdir = overlay('"',newdir,length(newdir)+1)
  'mkdir 'tempdir
*/
end



/* variables */
filelist.0 = 0
pathname = ''
filename= ''
fileprefix = ''
filesuffix = ''
newsuffix = ''

/* Create the list of files to decompress */

/* files under the main directory */
if cppdir \= '' then
do
   call GenFileList
   filelist = result
   call DecompCppFiles
end
exit


GenFileList:
/*The list of files to fix*/
/*files in the main directory are in filelist*/
  filelist.0=4
  filelist.1='bin\cppedsmp.exe'
  filelist.2='include\dde4u001.res'
  filelist.3='include\iwinpriv.inl'
  filelist.4='iocdll\getobjs.cmd'
return filelist

DecompCppFiles:

do i = 1 to filelist.0
  parse upper var filelist.i filelist.i
  call GetPath filelist.i
  pathname = result
  call GetFile filelist.i
  filename = result
  call GetPrefix filename
  fileprefix = result
  call GetSuffix filename
  filesuffix = result
  newsuffix = overlay("_",filesuffix,1)

  say 'Decompressing 'cppdir'\'filelist.i'...'
  'copy 'cppdir'\'filelist.i tempdir'\'fileprefix'.'newsuffix
  'del  'cppdir'\'filelist.i
  'decomp 'tempdir'\'fileprefix'.'newsuffix cppdir'\'filelist.i cppdir
  'del 'tempdir'\'fileprefix'.'newsuffix

end
return

GetPath: procedure

  parse arg file

  path = ''
  prefix = ''
  suffix = file

  do while suffix \= ''
     parse var suffix prefix '\' suffix
     if suffix \= '' then
       path = path||'\'||prefix
  end

return path


GetFile: procedure

  parse arg file

  suffix = file
  prefix = ''
  do while suffix \= ''
    parse var suffix prefix '\' suffix
  end

return prefix


GetPrefix: procedure

  parse arg file

  parse var file prefix '.' suffix

return prefix


GetSuffix: procedure

  parse arg file

  parse var file prefix '.' suffix


return suffix
